package pwc.taxtech.atms.web.controller;


import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.web.service.OrangeHeapService;

import javax.annotation.Resource;

@RestController
@RequestMapping("/OrangeHeap")
public class OrangeHeapController {

    @Resource
    private OrangeHeapService tableauService;

    @ResponseBody
    @GetMapping("unreturnedTax")
    public ApiResultDto getUnreturnedTax() {
        return ApiResultDto.success(tableauService.getUnreturnedTax().orElse(StringUtils.EMPTY));
    }

    //以上是示范代码
    //TODO 加入其他图表
    @ResponseBody
    @GetMapping("taxComparison")
    public ApiResultDto getTaxComparison() {
        return ApiResultDto.success(tableauService.getTaxComparison().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("otherCountries")
    public ApiResultDto getOtherCountries() {
        return ApiResultDto.success(tableauService.getOtherCountries().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("costAnalysis")
    public ApiResultDto getCostAnalysis() {
        return ApiResultDto.success(tableauService.getCostAnalysis().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("profitAndLoss")
    public ApiResultDto getProfitAndLoss() {
        return ApiResultDto.success(tableauService.getProfitAndLoss().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("otherDomesticData")
    public ApiResultDto getOtherDomesticData() {
        return ApiResultDto.success(tableauService.getOtherDomesticData().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("docSituation")
    public ApiResultDto getDocSituation() {
        return ApiResultDto.success(tableauService.getDocSituation().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("globalOverview")
    public ApiResultDto getGlobalOverview() {
        return ApiResultDto.success(tableauService.getGlobalOverview().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("mexicanTax")
    public ApiResultDto getMexicanTax() {
        return ApiResultDto.success(tableauService.getMexicanTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("australianTax")
    public ApiResultDto getAustralianTax() {
        return ApiResultDto.success(tableauService.getAustralianTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("brazilianTax")
    public ApiResultDto getBrazilianTax() {
        return ApiResultDto.success(tableauService.getBrazilianTax().orElse(StringUtils.EMPTY));
    }

}
